<?php
/**
* Scroll Feed - Joomla Module 
* Version			: 2.3.8
* Package			: Joomla 3.7.x
* copyright 		: Copyright (C) 2018 ConseilGouz. All rights reserved.
* license    		: http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
* Updated on        : April, 2018
*/
// no direct access
defined('_JEXEC') or die;
$com_path = JPATH_SITE . '/components/com_content/';
JModelLegacy::addIncludePath($com_path . '/models', 'ContentModel');
require_once $com_path . 'helpers/route.php';
class modScrollFeedHelper
{
	public static function getFeed($params)
	{
		// Module params
		$rssurl	= $params->get('rssurl', '');
		// Get RSS parsed object
		try
		{
			$feed = new JFeedFactory;
			$rssDoc = $feed->getFeed($rssurl);
		}
		catch (Exception $e)
		{
			return JText::_('MOD_FEED_ERR_FEED_NOT_RETRIEVED');
		}

		if (empty($rssDoc))
		{
			return JText::_('MOD_SF_ERR_FEED_NOT_RETRIEVED');
		}

		if ($rssDoc)
		{
			return $rssDoc;
		}
	}
	static function getArticle(&$id, $params) {
		// Get an instance of the generic articles model
		$model     = JModelLegacy::getInstance('Article', 'ContentModel', array('ignore_request' => true));
        if ($model) {
		// Set application parameters in model
		$app       = JFactory::getApplication();
		$appParams = $app->getParams();
		$model->setState('params', $appParams);

		// Set the filters based on the module params
		$model->setState('list.start', 0);
		$model->setState('list.limit', 1);
		$model->setState('filter.published', 1);
		$model->setState('filter.featured', $params->get('show_front', 1) == 1 ? 'show' : 'hide');

		// Access filter
		$access = !JComponentHelper::getParams('com_content')->get('show_noauth');
		$authorised = JAccess::getAuthorisedViewLevels(JFactory::getUser()->get('id'));
		$model->setState('filter.access', $access);

		// Category filter
		$model->setState('filter.category_id', $params->get('catid', array()));

		// Date filter
		$date_filtering = $params->get('date_filtering', 'off');

		if ($date_filtering !== 'off')
		{
			$model->setState('filter.date_filtering', $date_filtering);
			$model->setState('filter.date_field', $params->get('date_field', 'a.created'));
			$model->setState('filter.start_date_range', $params->get('start_date_range', '1000-01-01 00:00:00'));
			$model->setState('filter.end_date_range', $params->get('end_date_range', '9999-12-31 23:59:59'));
			$model->setState('filter.relative_date', $params->get('relative_date', 30));
		}
		// Filter by language
		$model->setState('filter.language', $app->getLanguageFilter());
		// Ordering
		$model->setState('list.ordering', 'a.hits');
		$model->setState('list.direction', 'DESC');

		$item = $model->getItem($id);

		$item->slug    = $item->id . ':' . $item->alias;
		$item->catslug = $item->catid . ':' . $item->category_alias;
		if ($access || in_array($item->access, $authorised))
		{
			// We know that user has the privilege to view the article
			$item->link = JRoute::_(ContentHelperRoute::getArticleRoute($item->slug, $item->catid, $item->language));
		}
		else
		{
			$item->link = JRoute::_('index.php?option=com_users&view=login');
		}
		$arr[0] = $item;
        }
        else {
        	$arr = false;
        }
		return $arr;
	}
	static function getCategory(&$id, $params) {
		// Get an instance of the generic articles model
		$articles = JModelLegacy::getInstance('Articles', 'ContentModel', array('ignore_request' => true));
		if ($articles) {
		// Set application parameters in model
		$app       = JFactory::getApplication();
		$appParams = $app->getParams();
		$articles->setState('params', $appParams);

		// Set the filters based on the module params
		$articles->setState('list.start', 0);
		$articles->setState('list.limit', (int) $params->get('count', 0));
		$articles->setState('filter.published', 1);

		// Access filter
		$access     = !JComponentHelper::getParams('com_content')->get('show_noauth');
		$authorised = JAccess::getAuthorisedViewLevels(JFactory::getUser()->get('id'));
		$articles->setState('filter.access', $access);
		$catids = $id;
		$articles->setState('filter.category_id', $catids);		
	
		// Filter by language
		$articles->setState('filter.language', $app->getLanguageFilter());
		$items = $articles->getItems();
		
				// Display options
		$show_date        = $params->get('show_date', 0);
		$show_date_field  = $params->get('show_date_field', 'created');
		$show_date_format = $params->get('show_date_format', 'Y-m-d H:i:s');
		$show_category    = $params->get('show_category', 0);
		$show_hits        = $params->get('show_hits', 0);
		$show_author      = $params->get('show_author', 0);
		$show_introtext   = true;
		$introtext_limit  = $params->get('introtext_limit', 100);

		// Prepare data for display using display options
		foreach ($items as &$item)
		{
			$item->slug    = $item->id . ':' . $item->alias;
			$item->catslug = $item->catid . ':' . $item->category_alias;

			if ($access || in_array($item->access, $authorised))
			{
				// We know that user has the privilege to view the article
				$item->link = JRoute::_(ContentHelperRoute::getArticleRoute($item->slug, $item->catid, $item->language));
			}
			else
			{
				$menu      = $app->getMenu();
				$menuitems = $menu->getItems('link', 'index.php?option=com_users&view=login');

				if (isset($menuitems[0]))
				{
					$Itemid = $menuitems[0]->id;
				}
				elseif ($app->input->getInt('Itemid') > 0)
				{
					// Use Itemid from requesting page only if there is no existing menu
					$Itemid = $app->input->getInt('Itemid');
				}

				$item->link = JRoute::_('index.php?option=com_users&view=login&Itemid=' . $Itemid);
			}

			// Used for styling the active article
			$item->displayDate = '';

			if ($show_date)
			{
				$item->displayDate = JHtml::_('date', $item->$show_date_field, $show_date_format);
			}

			if ($item->catid)
			{
				$item->displayCategoryLink  = JRoute::_(ContentHelperRoute::getCategoryRoute($item->catid));
				$item->displayCategoryTitle = $show_category ? '<a href="' . $item->displayCategoryLink . '">' . $item->category_title . '</a>' : '';
			}
			else
			{
				$item->displayCategoryTitle = $show_category ? $item->category_title : '';
			}

			$item->displayHits       = $show_hits ? $item->hits : '';
			$item->displayAuthorName = $show_author ? $item->author : '';

			if ($show_introtext)
			{
				$item->introtext = JHtml::_('content.prepare', $item->introtext, '', 'mod_articles_category.content');
				$item->introtext = self::cleanIntrotext($item->introtext);
			}

			$item->displayIntrotext = $show_introtext ? self::truncate($item->introtext, $introtext_limit) : '';
			$item->displayReadmore  = $item->alternative_readmore;
		}

		return $items;
		}
		else { return false;
		}

	}
	// get tag title & tag alias
	public static function getTags($id) {
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		// Construct the query
		$query->select('tags.title as tag, tags.alias as alias ')
			->from('#__tags as tags')
			->where('tags.id = '.$id)
			;
		$db->setQuery($query);
		return $db->loadResult();
	}
	public static function cleanIntrotext($introtext)
	{
		$introtext = str_replace('<p>', ' ', $introtext);
		$introtext = str_replace('</p>', ' ', $introtext);
		$introtext = strip_tags($introtext, '<a><em><strong><img>');
		$introtext = trim($introtext);
		return $introtext;
	}

	public static function truncate($html, $maxLength = 0)
	{
		$baseLength = strlen($html);
		$ptString = JHtml::_('string.truncate', $html, $maxLength, $noSplit = true, $allowHtml = false);
		for ($maxLength; $maxLength < $baseLength;)
		{
			$htmlString = JHtml::_('string.truncate', $html, $maxLength, $noSplit = true, $allowHtml = true);
			$htmlStringToPtString = JHtml::_('string.truncate', $htmlString, $maxLength, $noSplit = true, $allowHtml = false);
			if ($ptString == $htmlStringToPtString)
			{
				return $htmlString;
			}
			$diffLength = strlen($ptString) - strlen($htmlStringToPtString);
			$maxLength += $diffLength;
			if ($baseLength <= $maxLength || $diffLength <= 0)
			{
				return $htmlString;
			}
		}
		return $html;
	}
	public static function showDirection($num_sf,$sf_direction) { 
		echo '<span class="hidden-phone" id="toDirection">';
		if ($sf_direction == 1)	{ 
			echo '<span class="icon-dir-down"></span>';
			echo '<span id="toDirectionText"> </span>';
			echo '<span class="icon-dir-up"></span>';
			echo '<span id="toDirText"> </span>';
		} else {
			echo '<span class="icon-dir-left"></span>';
			echo '<span id="toDirectionText"> </span>';
			echo '<span class="icon-dir-right"></span>';
			echo '<span id="toDirText"> </span>';
		}
		echo '</span>';
	
	}
	public static function getAjax() {
        $input = JFactory::getApplication()->input;
		$id = $input->get('id');
		$module = self::getModuleById($id);
		$params = new JRegistry($module->params);  		
        $output = '';
		if ($input->get('data') == "param") {
			return self::getParams($id,$params);
		}
		return false;
	}
	private static function getModuleById($id) {
		$db = JFactory::getDbo();
		$query = $db->getQuery(true)
			->select('m.id, m.title, m.module, m.position, m.content, m.showtitle, m.params')
			->from('#__modules AS m')
			->where('m.id = '.(int)$id);
		$db->setQuery($query);
		return $db->loadObject();
	}
	private static function getParams($id,$params) {
		$sf_type = $params->get('sf_type', 'FEED');		
		if ($sf_type == 'FEED') {
			$count   = $params->get('rssitems',3);
		} else {
			$count   = $params->get('catitems',3);
		}
		$sf_width   = $params->get('sf_width', 200);
		$sf_speed	= $params->get('sf_speed', 2);
		$sf_height	= $params->get('sf_height', 200);
		$sf_pause	= $params->get('sf_pause', 1);
		$sf_direction = $params->get('direction', 0);
		$ret = '{"id":"'.$id.'","speed":"'.$sf_speed.'","pause":"'.$sf_pause.'","height":"'.$sf_height.'","width":"'.$sf_width.'","direction":"'.$sf_direction.'","count":"'.$count.'"}';
		return $ret;		
	}
}